<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="../bower_components/paper-input/paper-input.js">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">
<link rel="import" href="../bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="../bower_components/iron-form/iron-form.js">
<link rel="import" href="shared-styles.html">
<link rel="import" href="shop-input.js">

<dom-module id="my-registro">
  <template>
    <style include="shared-styles">
      :host {
        display: block;
        width: auto;
      }
    </style>
    <style include="shop-common-styles shop-button shop-form-styles shop-input shop-select shop-checkbox">
      shop-input,
      shop-select {
        font-family: BentonSans-Medium;
        font-size: 14px;
        color: black;
        letter-spacing: 0;
        line-height: 24px;
        padding: 10px;
      }

      .label {
        color: black;
      }
    </style>

    <div class="imgRegistro">
      <img src="../images/login.png" alt="" height="auto" width="320px">
    </div>
    <div class="formularioRegistro">
      <div class="titleRegistro">Registro</div>
      <form is="iron-form" id="form-login" method="POST" action="/v5/login">
        <!--  -->
        <div class="titleRegistro">
          <shop-input>
            <input type="nombre" id="nombre" name="nombre" placeholder="Nombre" value="{{nombre::input}}"
            autofocus required aria-labelledby="" onkeyup="">
            <shop-md-decorator error-message="Formato incorrecto" aria-hidden="true">
              <label>Nombre</label>
              <shop-underline></shop-underline>
            </shop-md-decorator>
          </shop-input>
        </div>
        <div class="titleRegistro">
          <shop-input>
            <input type="text" id="paterno" name="paterno" placeholder="Apellido Paterno" value="{{apellido::input}}"
            autofocus required aria-labelledby="" >
            <shop-md-decorator error-message="Formato incorrecto" aria-hidden="true">
              <label id="">Apellido paterno</label>
              <shop-underline></shop-underline>
            </shop-md-decorator>
          </shop-input>
        </div>
        <div class="titleRegistro">
          <shop-input>
            <input type="text" id="email" name="usuario" placeholder="Usuario" autofocus required
            value="{{email::input}}" aria-labelledby="" >
            <shop-md-decorator error-message="Formato incorrecto" aria-hidden="true">
              <label id="">Usuario</label>
              <shop-underline></shop-underline>
            </shop-md-decorator>
          </shop-input>
        </div>
        <div class="titleRegistro">
          <shop-input>
            <input type="password" id="password" name="password"  placeholder="Contraseña" required
            value="{{password::input}}" aria-labelledby="accountPhoneLabel accountInfoHeading" >
            <shop-md-decorator error-message="Formato incorrecto" aria-hidden="true">
              <label id="">Contraseña</label>
                <shop-underline></shop-underline>
              </shop-md-decorator>
            </shop-input>
          </div>
          <div class="titleRegistro">
            <shop-input>
              <input type="password" id="password" name="confirmPassword"  placeholder="Confirmasr Contraseña"
              required aria-labelledby="accountPhoneLabel accountInfoHeading"  >
              <shop-md-decorator error-message="Formato incorrecto" aria-hidden="true">
                <label id="">Confirmar Contraseña</label>
                  <shop-underline></shop-underline>
                </shop-md-decorator>
              </shop-input>
            </div>
          <div class=" titleRegistro">
                <div class="container flex-button">
                  <a class="paper-item-link" name="view2" href="[[rootPath]]login" tabindex="-1">
                    <paper-item>
                      <paper-button raised on-click="register" >ENTRAR </paper-button>
                    </paper-item>
                  </a>

                </div>

        </div>
      </form>
    </div>

    <iron-ajax id="doIdentificadorCliente" url="http://localhost:3000/v5/Identificador/C" content-type="application/json" crossDomain:true
      dataType:'jsonp' method="Get" handle-as="json" headers="Access-Control-Allow-Headers: *"
      on-response="manageAJAXResponse" on-error="showError">
      <iron-ajax id="doIdentificadorUsuario" url="http://localhost:3000/v5/Identificador/U" content-type="application/json" crossDomain:true
        dataType:'jsonp' method="Get" handle-as="json" headers="Access-Control-Allow-Headers: *"
        on-response="manageAJAXResponse" on-error="showError">
      <iron-ajax id="doRegister" url="http://localhost:3000/v5/register" content-type="application/json" crossDomain:true
        dataType:'jsonp' method="POST" handle-as="json" headers="Access-Control-Allow-Headers: *"
        on-response="manageAJAXResponse" on-error="showError">
  </template>

  <script>
    class MyRegistro extends Polymer.Element {
      static get is() {
        return 'my-registro';
      }

      static get properties() {
        return {
          nombre: {
            type: String,
            notify: true
          },
          apellido: {
            type: String,
          },
          email:{
            type: String,
          },
          password: {
            type: String
          },
          registrado: {
            type: Boolean,
            value: false
          }
        }
      }

      register() {
         var identificadorClienteData = {
           "idcliente": this.id
         }
          var identificadorUsuarioData = {
            "idUsuario": this.id
          }
          var registerData = {
            "nombre": this.nombre,
            "apellido": this.apellido,
            "email": this.email,
            "password": this.password
          }

          this.$.doIdentificadorCliente.params.id = JSON.stringify(identificadorClienteData);
          this.$.doIdentificadorUsuario.params.id = JSON.stringify(identificadorUsuarioData);
          this.$.doRegister.body = JSON.stringify(registerData);

        if(identificadorClienteData|| identificadorUsuarioData || registerData){
          this.$.doIdentificadorCliente.generateRequest();
          this.$.doIdentificadorUsuario.generateRequest();
          this.$.doRegister.generateRequest();
          console.log("Petición enviada");
        }

      }
      manageAJAXResponse(data) {
        console.log("Respuesta recibida del servidor");
        console.log(data.detail.response);
        this.logado = true;
      }

      showError(error) {
        console.log("Hubo un error en la petición");
        console.log(error);
      }
    }

    window.customElements.define(MyRegistro.is, MyRegistro);
  </script>
</dom-module>
